#!/usr/bin/env python3

import subprocess
import sys

import captaintrain as ct


if __name__ == "__main__":
    if len(sys.argv) > 3:
        departure = ct.station(sys.argv[1])
        arrival = ct.station(sys.argv[2])
        departure_time = 0

        with subprocess.Popen(["date", "-d", sys.argv[3], "-u", "-Iseconds"], stdout=subprocess.PIPE) as f:
            departure_time = f.stdout.read().strip().decode()

        if departure_time == 0 or departure_time == "":
            sys.exit(1)
        else:
            departure_time = ct.parse_datetime(departure_time)

        print("From:", departure.name, departure.id)
        print("To:", arrival.name, arrival.id)
        print("Departure:", departure_time)

        #with open("res.json") as f:
        #    import json
        #    res = json.load(f)

        res = ct.search(departure, arrival, departure_time)
        min_trips = ct.cheapest_trips(res["trips"])
        for trip in min_trips:
            print(ct.display_trip(trip, res["stations"], res["segments"]))
    else:
        print("usage")
